#!/usr/bin/perl

# Determine what NMAP OS is emulated on a given IP address
# Usage: ./getos.pl C.D [nmap]
#   The first argument specifies the last two octets of an IP address.  The
#     first two octets are 10.2, resulting in an IP address of 10.2.C.D
#   The second optional argument is the word "nmap", which, if present, will
#     cause the program to display the NMAP fingerprint information associated
#     with the given IP address.

open FILE, "honeyd.config" or die "Can't open file\n";
while (<FILE>)
{
	/bind 10.2.(.*) t(.*)$/;
	if ($1 eq $ARGV[0])
	{
		print "10.2.$1 is t$2\n" if ($1 && $2);
		$template = $2;
		last;
	}
}
close FILE;
open FILE, "honeyd.config" or die "Can't open file\n";
while (<FILE>)
{
	/set t$template personality \"(.*)\"/;
	if ($1)
	{
		$os = $1;
		last;
	}
}
close FILE;
print "$os\n";

if ($ARGV[1] eq "nmap")
{
	$verbose = 0;
	$os = quotemeta $os;
	open FILE, "nmap-os-fingerprints" or die "Can't open file\n";
	while (<FILE>)
	{
		$verbose = 0 if (/Fingerprint/);
		print "$_" if ($verbose && $_ ne "\n");
		$verbose = 1 if (/Fingerprint $os/);
		#print "$_" if (/Fingerprint $os/);
	}
}
close FILE;
