#!/usr/bin/perl

$ip_prefix = "10.2";
$fp_file = "nmap-os-fingerprints";
$out_file = "honeyd.config";

@oses = ();

# Get a list of all OSes
@oslist = `cat $fp_file | grep -v \"\^#\" | grep -i Fingerprint | cut -d \' \' -f 2-`;
chomp(@oslist);

foreach $os (@oslist)
{
	($osonly, undef) = split /#/, $os;
	while ($osonly =~ / $/)
	{
		chop($osonly);
	}
	push @oses, $osonly;
}

open CONFIG, ">$out_file";
$i = 1;

foreach $os (@oses)
{
	print CONFIG "create t$i\n";
	print CONFIG "set t$i personality \"$os\"\n";
	print CONFIG "add t$i tcp port 80 \"sh scripts/web.sh\"\n";
	print CONFIG "set t$i default tcp action reset\n\n";
	$i++;
}

while (--$i)
{	
	$c = int ($i / 254) + 1;
	$d = $i % 254 + 1;
	print CONFIG "bind $ip_prefix.$c.$d t$i\n";
}
close CONFIG;
