#!/usr/bin/perl

$ip_prefix = "10.2";
$fp_file = "nmap-os-fingerprints";

@oses = ();

# Get a list of all OSes
@oslist = `cat $fp_file | grep -v \"\^#\" | grep -i Fingerprint | cut -d \' \' -f 2-`;
chomp(@oslist);
$i = 1;

open OUT, ">>scan.txt";
$date = `date`;
print OUT "$date\n";
close OUT;

foreach $os (@oslist)
{
        ($osonly, undef) = split /#/, $os;
        while ($osonly =~ / $/)
        {
                chop($osonly);
        }
        push @oses, $osonly;
	$i++;
}


while (--$i)
{
	open OUT, ">>scan.txt";
	sleep 1;
        $c = int ($i / 254) + 1;
        $d = $i % 254 + 1;
	$command = "nmap -sS -P0 -p 80,2000 -O --osscan_guess -T insane $ip_prefix.$c.$d 2>/dev/null | grep \"guess\\\|No OS\"";
	$res = `$command`;
	chomp($res);
	if ($res =~ /Remote/)	# Thinks it guess correctly
	{
		($useless, $OS) = split /:/,$res,2;
		$OS = substr($OS, 1);
		if ($oses[$i - 1] eq substr($OS, 0, length($oses[$i - 1])))
		{
			print OUT "+";
		}
		elsif ($OS =~ /$oses[$i - 1]/)
		{
			print OUT "~";
		}
		else
		{
			print OUT "-";
		}
		print OUT "NMAP is sure $ip_prefix.$c.$d is $OS\n"; #  Should be $oses[$i - 1]\n";
	}
	elsif ($res =~ /Aggressive/) # Didn't match exactly
	{
		($useless, $OS) = split /:/,$res,2;
		($OS, undef) = split /%/,$OS,2;
		$OS = substr($OS, 1) . "%)";
		if ($oses[$i - 1] eq substr($OS, 0, length($oses[$i - 1])))
		{
			print OUT "+";
		}
		else
		{
			print OUT "-";
		}
		print OUT "NMAP guesses $ip_prefix.$c.$d is $OS\n"; #  Should be $oses[$i - 1]\n";
	}
	elsif ($res =~ /Too many/)
	{
		print OUT "-NMAP found too many matches for $ip_prefix.$c.$d - $oses[$i - 1]\n";
	}
	else
	{
		print OUT "-NMAP found no match for $ip_prefix.$c.$d which is $oses[$i - 1]\n";
	}
	close OUT;
}

open OUT, ">>scan.txt";
$date = `date`;
print OUT "$date\n";
close OUT;
